export interface IConfig {
	service?: string;
	region?: string;
}

export interface IRequestOptions extends IConfig {
	date?: string;
}

export interface IRequest {
	method?: string;
	pathname?: string;
	query?: string;
	headers?: Headers | Record<string, any>;
	body?: any;
}

export interface ISignature {
	Algorithm: 'AWS4-HMAC-SHA256';
	Credential: string;
	SignedHeaders: string;
	Signature: string;
}

export type IFactory = (req: IRequest, opts?: IRequestOptions) => Promise<ISignature>;

export default function (clientKey: string, secretKey: string, config?: IConfig): IFactory;
